package hu.bme.kszk.kikerdezo

import android.content.Intent
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.preference.PreferenceManager
import android.provider.AlarmClock.EXTRA_MESSAGE
import android.util.Log
import android.widget.Button
import android.widget.TextView
import android.widget.Toast
import androidx.core.view.GravityCompat
import androidx.drawerlayout.widget.DrawerLayout
import com.google.android.material.appbar.MaterialToolbar
import com.google.android.material.navigation.NavigationView
import hu.bme.kszk.kikerdezo.connection.NetworkManager
import hu.bme.kszk.kikerdezo.database.AppDatabase
import hu.bme.kszk.kikerdezo.databinding.ActivityMainBinding
import hu.bme.kszk.kikerdezo.model.QuestionData
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import kotlin.concurrent.thread

class MainActivity : AppCompatActivity() {
    private lateinit var binding: ActivityMainBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        binding = ActivityMainBinding.inflate(layoutInflater)

        if (isFirstStart()) {
            startActivity(Intent(this, UserName::class.java))
        }

        val topAppBar = findViewById<MaterialToolbar>(R.id.topAppBar)
        val btn1 = findViewById<Button>(R.id.btn1)
        val btn2 = findViewById<Button>(R.id.btn2)
        val btn3 = findViewById<Button>(R.id.btn3)
        val btn4 = findViewById<Button>(R.id.btn4)
        val btn5 = findViewById<Button>(R.id.btn5)
        val btn6 = findViewById<Button>(R.id.btn6)
        val btn7 = findViewById<Button>(R.id.btn7)
        val btn8 = findViewById<Button>(R.id.btn8)
        val btn9 = findViewById<Button>(R.id.btn9)
        val btn10 = findViewById<Button>(R.id.btn10)
        val btn11 = findViewById<Button>(R.id.btn11)
        val btn12 = findViewById<Button>(R.id.btn12)
        val btn13 = findViewById<Button>(R.id.btn13)

        val drawerLayout = findViewById<DrawerLayout>(R.id.drawer_layout)
        val navigationView = findViewById<NavigationView>(R.id.navigation_view)

        setUserName()


        topAppBar.setNavigationOnClickListener {
            drawerLayout.openDrawer(navigationView)
        }

        initdatabaseFromApi()

        btn1.setOnClickListener {
            Log.d("BUTTON", "Gomb megnyomva!")

            val intent = Intent(this, QuestionListActivity::class.java).apply {
                putExtra(EXTRA_MESSAGE, 1)
            }
            startActivity(intent)

        }
        btn2.setOnClickListener {
            Log.d("BUTTON", "Gomb megnyomva!")

            val intent = Intent(this, QuestionListActivity::class.java).apply {
                putExtra(EXTRA_MESSAGE, 2)
            }
            startActivity(intent)
        }
        btn3.setOnClickListener {
            Log.d("BUTTON", "Gomb megnyomva!")

            val intent = Intent(this, QuestionListActivity::class.java).apply {
                putExtra(EXTRA_MESSAGE, 3)
            }
            startActivity(intent)
        }
        btn4.setOnClickListener {
            Log.d("BUTTON", "Gomb megnyomva!")



            val intent = Intent(this, QuestionListActivity::class.java).apply {
                putExtra(EXTRA_MESSAGE, 4)
            }
            startActivity(intent)
        }
        btn5.setOnClickListener {
            Log.d("BUTTON", "Gomb megnyomva!")

            val intent = Intent(this, QuestionListActivity::class.java).apply {
                putExtra(EXTRA_MESSAGE, 5)
            }
            startActivity(intent)
        }
        btn6.setOnClickListener {
            Log.d("BUTTON", "Gomb megnyomva!")

            val intent = Intent(this, QuestionListActivity::class.java).apply {
                putExtra(EXTRA_MESSAGE, 6)
            }
            startActivity(intent)
        }
        btn7.setOnClickListener {
            Log.d("BUTTON", "Gomb megnyomva!")

            val intent = Intent(this, QuestionListActivity::class.java).apply {
                putExtra(EXTRA_MESSAGE, 7)
            }
            startActivity(intent)
        }
        btn8.setOnClickListener {
            Log.d("BUTTON", "Gomb megnyomva!")


            val intent = Intent(this, QuestionListActivity::class.java).apply {
                putExtra(EXTRA_MESSAGE, 8)
            }
            startActivity(intent)
        }
        btn9.setOnClickListener {
            Log.d("BUTTON", "Gomb megnyomva!")

            val intent = Intent(this, QuestionListActivity::class.java).apply {
                putExtra(EXTRA_MESSAGE, 9)
            }
            startActivity(intent)
        }
        btn10.setOnClickListener {
            Log.d("BUTTON", "Gomb megnyomva!")


            val intent = Intent(this, QuestionListActivity::class.java).apply {
                putExtra(EXTRA_MESSAGE, 10)
            }
            startActivity(intent)
        }
        btn11.setOnClickListener {
            Log.d("BUTTON", "Gomb megnyomva!")


            val intent = Intent(this, QuestionListActivity::class.java).apply {
                putExtra(EXTRA_MESSAGE, 11)
            }
            startActivity(intent)
        }
        btn12.setOnClickListener {
            Log.d("BUTTON", "Gomb megnyomva!")


            val intent = Intent(this, QuestionListActivity::class.java).apply {
                putExtra(EXTRA_MESSAGE, 12)
            }
            startActivity(intent)
        }
        btn13.setOnClickListener {
            Log.d("BUTTON", "Gomb megnyomva!")


            val intent = Intent(this, QuestionListActivity::class.java).apply {
                putExtra(EXTRA_MESSAGE, 13)
            }
            startActivity(intent)
        }


        navigationView.setNavigationItemSelectedListener { menuItem ->
            val id = menuItem.itemId
            if (id == R.id.eredmenyek) {
                startActivity(Intent(this, ResultsActivity::class.java))
            } else if (id == R.id.nev_megadas) {
                startActivity(Intent(this, UserName::class.java))
            }
            drawerLayout.closeDrawer(GravityCompat.START)
            true
        }
    }

    override fun onRestart() {
        super.onRestart()
        setUserName()
    }

    private fun setUserName() {
        val navigationView = findViewById<NavigationView>(R.id.navigation_view)
        val headerView = navigationView.getHeaderView(0)
        val name = headerView.findViewById<TextView>(R.id.playerName)

        val sp = PreferenceManager.getDefaultSharedPreferences(this)


        sp.getString("USERNAME", "PlayerOne")?.let { Log.d("USERNAME", it) }
        name.text?.let { name.text =  sp.getString("USERNAME", "PlayerOne").toString() }
    }


    fun isFirstStart() : Boolean {
        val sp = PreferenceManager.getDefaultSharedPreferences(this)
        return !sp.getBoolean("KEY_STARTED", false)
    }

    private fun initdatabaseFromApi() {
        NetworkManager.getQuestion()?.enqueue(object : Callback<QuestionData?>{
            override fun onResponse(
                call: Call<QuestionData?>,
                response: Response<QuestionData?>
            ) {
                Log.d("alma", "onResponse: " + response.code())
                if (response.isSuccessful) {
                    loadToDatabase(response.body())
                } else {
                    Toast.makeText(this@MainActivity, "Error: " + response.message(), Toast.LENGTH_LONG).show()
                }
            }

            override fun onFailure(call: Call<QuestionData?>, throwable: Throwable){
                throwable.printStackTrace()
                Toast.makeText(this@MainActivity, "Network request error occured, check LOG", Toast.LENGTH_LONG).show()
            }
        })
    }

    private fun loadToDatabase(recivedQuestionData: QuestionData?) {
        thread{
            AppDatabase.getInstanceQuestion(this@MainActivity).clearAllTables()
            if (recivedQuestionData != null) {
                if(recivedQuestionData.data != null) {
                    for (question in recivedQuestionData.data!!)
                        AppDatabase.getInstanceQuestion(this).questionDao().insertQuestion(
                            question
                        )
                    Log.d("DATABASE_LOADED", "database loaded to sqlite")
                }
            }
        }
    }
}