package hu.bme.kszk.kikerdezo

import android.content.Intent
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.preference.PreferenceManager
import android.util.Log
import android.widget.TextView
import androidx.core.view.GravityCompat
import androidx.drawerlayout.widget.DrawerLayout
import androidx.recyclerview.widget.RecyclerView
import com.google.android.material.appbar.MaterialToolbar
import com.google.android.material.navigation.NavigationView
import hu.bme.kszk.kikerdezo.adapter.ResultAdapter
import hu.bme.kszk.kikerdezo.database.AppDatabase

class ResultsActivity : AppCompatActivity() {

    private lateinit var resAdapter : ResultAdapter

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_results)

        setUserName()

        val topAppBar = findViewById<MaterialToolbar>(R.id.topAppBar)
        val drawerLayout = findViewById<DrawerLayout>(R.id.drawer_layout)
        val navigationView = findViewById<NavigationView>(R.id.navigation_view)

        topAppBar.setNavigationOnClickListener {
            drawerLayout.openDrawer(navigationView)
        }

        navigationView.setNavigationItemSelectedListener { menuItem ->
            val id = menuItem.itemId
            if (id == R.id.eredmenyek) {
                //Semmi, itt vagy pls
            } else if (id == R.id.nev_megadas) {
                startActivity(Intent(this, UserName::class.java))
            } else if (id == R.id.kikerdezo) {
                finish() //csak onnan lehet elinditani
            }
            drawerLayout.closeDrawer(GravityCompat.START)
            true
        }

        initRecycleView()
    }

    private fun initRecycleView() {
        resAdapter = ResultAdapter(this)
        val rvResults: RecyclerView = findViewById(R.id.rvResults)
        rvResults.adapter = resAdapter
        AppDatabase.getInstanceResult(this@ResultsActivity).resultsDao().getResults().observe(this, { results ->
            resAdapter.submitList(results)
        })
    }

    private fun setUserName() {
        val navigationView = findViewById<NavigationView>(R.id.navigation_view)
        val headerView = navigationView.getHeaderView(0)
        val name = headerView.findViewById<TextView>(R.id.playerName)

        val sp = PreferenceManager.getDefaultSharedPreferences(this)


        sp.getString("USERNAME", "PlayerOne")?.let { Log.d("USERNAME", it) }
        name.text?.let { name.text =  sp.getString("USERNAME", "PlayerOne").toString() }
    }
}