package hu.bme.kszk.kikerdezo.adapter

import android.content.Context
import android.graphics.Color
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import androidx.recyclerview.widget.ListAdapter
import android.widget.TextView
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.RecyclerView
import hu.bme.kszk.kikerdezo.R
import hu.bme.kszk.kikerdezo.model.Question


class Adapter(val context: Context) : ListAdapter<Question, Adapter.QuestionViewHolder>(QuestionDiffCallback) {

    class QuestionViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView)  {
        private val questionText: TextView = itemView.findViewById(R.id.question)
        private val ans1: Button = itemView.findViewById(R.id.btnAns1)
        private val ans2: Button = itemView.findViewById(R.id.btnAns2)
        private val ans3: Button = itemView.findViewById(R.id.btnAns3)
        private val ans4: Button = itemView.findViewById(R.id.btnAns4)
        var correct:  Int =  0
        var selected: Int = -1

        init{
            ans1.setOnClickListener{
                selected = 1
                ans1.setBackgroundColor(Color.GREEN)
                ans2.setBackgroundColor(Color.CYAN)
                ans3.setBackgroundColor(Color.CYAN)
                ans4.setBackgroundColor(Color.CYAN)

            }
            ans2.setOnClickListener{
                selected = 2
                ans1.setBackgroundColor(Color.CYAN)
                ans2.setBackgroundColor(Color.GREEN)
                ans3.setBackgroundColor(Color.CYAN)
                ans4.setBackgroundColor(Color.CYAN)

            }
            ans3.setOnClickListener{
                selected = 3
                ans2.setBackgroundColor(Color.CYAN)
                ans3.setBackgroundColor(Color.GREEN)
                ans4.setBackgroundColor(Color.CYAN)
                ans1.setBackgroundColor(Color.CYAN)

            }
            ans4.setOnClickListener{
                selected = 4
                ans1.setBackgroundColor(Color.CYAN)
                ans2.setBackgroundColor(Color.CYAN)
                ans3.setBackgroundColor(Color.CYAN)
                ans4.setBackgroundColor(Color.GREEN)

            }
        }

        fun bind(question: Question){
            correct = question.correct

            ans1.text = question.answer1
            ans2.text = question.answer2
            ans3.text = question.answer3
            ans4.text = question.answer4
            questionText.text = question.questionText
        }
    }

    // Create new views (invoked by the layout manager)
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int) : QuestionViewHolder {
        // Create a new view, which defines the UI of the list item
        val view = LayoutInflater.from(parent.context)
            .inflate(R.layout.question_item, parent, false)

        return QuestionViewHolder(view)
    }

    // Replace the contents of a view (invoked by the layout manager)
    override fun onBindViewHolder(holder: QuestionViewHolder, position: Int) {
        val question = getItem(position)
        holder.bind(question)
    }
}

object QuestionDiffCallback : DiffUtil.ItemCallback<Question>() {
    override fun areItemsTheSame(oldItem: Question, newItem: Question): Boolean {
        return oldItem == newItem
    }

    override fun areContentsTheSame(oldItem: Question, newItem: Question): Boolean {
        return oldItem.id == newItem.id
    }
}
