package hu.bme.kszk.kikerdezo.adapter

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.recyclerview.widget.DiffUtil
import androidx.recyclerview.widget.ListAdapter
import androidx.recyclerview.widget.RecyclerView
import hu.bme.kszk.kikerdezo.R
import hu.bme.kszk.kikerdezo.model.Result

class ResultAdapter(val context: Context) :
    ListAdapter<Result, ResultAdapter.ResultViewHolder>(ResultDiffCallback){

        class ResultViewHolder(itemView: View):
            RecyclerView.ViewHolder(itemView) {
            private val score: TextView = itemView.findViewById(R.id.score)
            private val name:  TextView = itemView.findViewById(R.id.name)
            private val date:  TextView = itemView.findViewById(R.id.date)
            private val labNum: TextView = itemView.findViewById(R.id.labNum)

                fun bind(result: Result){
                    score.text = result.score.toString()
                    name.text  = result.uname
                    labNum.text = result.lab.toString()
                    date.text  = result.date
                }
            }
        override fun onCreateViewHolder(parent: ViewGroup, viewType: Int) : ResultViewHolder {
            // Create a new view, which defines the UI of the list item
            val view = LayoutInflater.from(parent.context)
                .inflate(R.layout.result_item, parent, false)

            return ResultViewHolder(view)
        }
        override fun onBindViewHolder(holder: ResultViewHolder, position: Int) {
            val result = getItem(position)
            holder.bind(result)
        }



    }

object ResultDiffCallback : DiffUtil.ItemCallback<Result>() {
    override fun areItemsTheSame(oldItem: Result, newItem: Result): Boolean {
        return oldItem == newItem
    }

    override fun areContentsTheSame(oldItem: Result, newItem: Result): Boolean {
        return oldItem.id == newItem.id
    }
}