package hu.bme.kszk.kikerdezo.connection

import hu.bme.kszk.kikerdezo.model.QuestionData
import okhttp3.OkHttpClient
import retrofit2.Call
import retrofit2.Retrofit
import retrofit2.converter.gson.GsonConverterFactory

object NetworkManager {
    private val retrofit: Retrofit
    private val questionApi: QuestionApi

    private const val SERVICE_URL = "https://mobweb-clupus.k8s-01.sch.bme.hu"

    init{
        retrofit = Retrofit.Builder()
            .baseUrl(SERVICE_URL)
            //.client(OkHttpClient.Builder().build())
            .addConverterFactory(GsonConverterFactory.create())
            .build()
        questionApi = retrofit.create(QuestionApi::class.java)
    }

    fun getQuestion(): Call<QuestionData?>? {
        return questionApi.getQuestion()
    }
}