package hu.bme.kszk.kikerdezo.database

import android.content.Context
import androidx.room.Database
import androidx.room.Room
import androidx.room.RoomDatabase
import hu.bme.kszk.kikerdezo.model.Question
import hu.bme.kszk.kikerdezo.model.Result

@Database(entities = [Question::class, Result::class], version = 1)
abstract class AppDatabase : RoomDatabase() {
    abstract fun questionDao(): QuestionDao
    abstract fun resultsDao(): ResultDao

    companion object {
        private var INSTANCE: AppDatabase? = null
        private var INSTANCE2: AppDatabase? = null

        fun getInstanceQuestion(context: Context): AppDatabase {
            if (INSTANCE == null) {
                INSTANCE = Room.databaseBuilder(context.applicationContext,
                    AppDatabase::class.java, "question.db")
                    //.fallbackToDestructiveMigration()
                    .build()
            }
            return INSTANCE!!
        }
        fun getInstanceResult(context: Context): AppDatabase {
            if (INSTANCE2 == null) {
                INSTANCE2 = Room.databaseBuilder(context.applicationContext,
                    AppDatabase::class.java, "result.db")
                    //.fallbackToDestructiveMigration()
                    .build()
            }
            return INSTANCE2!!
        }
    }
}